#include "ievent.h"


#if HAVE_DVB_API_VERSION == 3

/******************************************************************************
 * GetRCCode
 ******************************************************************************/

int GetRCCode()
{
	struct input_event ev;

	//get code

		if(read(rc, &ev, sizeof(ev)) == sizeof(ev))
		{
			if(ev.value)
			{
				switch(ev.code)
				{
					case KEY_UP:		rccode = RC_UP;
								break;

					case KEY_DOWN:		rccode = RC_DOWN;
								break;

					case KEY_LEFT:		rccode = RC_LEFT;
								break;

					case KEY_RIGHT:		rccode = RC_RIGHT;
								break;

					case KEY_OK:		rccode = RC_OK;
								break;

					case KEY_0:		rccode = RC_0;
								break;

					case KEY_1:		rccode = RC_1;
								break;

					case KEY_2:		rccode = RC_2;
								break;

					case KEY_3:		rccode = RC_3;
								break;

					case KEY_4:		rccode = RC_4;
								break;

					case KEY_5:		rccode = RC_5;
								break;

					case KEY_6:		rccode = RC_6;
								break;

					case KEY_7:		rccode = RC_7;
								break;

					case KEY_8:		rccode = RC_8;
								break;

					case KEY_9:		rccode = RC_9;
								break;

					case KEY_RED:		rccode = RC_RED;
								break;

					case KEY_GREEN:		rccode = RC_GREEN;
								break;

					case KEY_YELLOW:	rccode = RC_YELLOW;
								break;

					case KEY_BLUE:		rccode = RC_BLUE;
								break;

					case KEY_VOLUMEUP:	rccode = RC_PLUS;
								break;

					case KEY_VOLUMEDOWN:	rccode = RC_MINUS;
								break;

					case KEY_MUTE:		rccode = RC_MUTE;
								break;

					case KEY_HELP:		rccode = RC_HELP;
								break;

					case KEY_SETUP:		rccode = RC_DBOX;
								break;

					case KEY_HOME:		rccode = RC_HOME;
								break;

					case KEY_POWER:		rccode = RC_STANDBY;
				}
			}
			else rccode = -1;
		}

		return rccode;
}

#else

/******************************************************************************
 * GetRCCode
 ******************************************************************************/

int GetRCCode()
{
	static unsigned short LastKey = -1;

	//get code

		read(rc, &rccode, 2);

		if(rccode != LastKey)
		{
			LastKey = rccode;

			//translation required?

				if((rccode & 0xFF00) == 0x5C00)
				{
					switch(rccode)
					{
						case RC1_UP:		rccode = RC_UP;
									break;

						case RC1_DOWN:		rccode = RC_DOWN;
									break;

						case RC1_LEFT:		rccode = RC_LEFT;
									break;

						case RC1_RIGHT:		rccode = RC_RIGHT;
									break;

						case RC1_OK:		rccode = RC_OK;
									break;

						case RC1_0:		rccode = RC_0;
									break;

						case RC1_1:		rccode = RC_1;
									break;

						case RC1_2:		rccode = RC_2;
									break;

						case RC1_3:		rccode = RC_3;
									break;

						case RC1_4:		rccode = RC_4;
									break;

						case RC1_5:		rccode = RC_5;
									break;

						case RC1_6:		rccode = RC_6;
									break;

						case RC1_7:		rccode = RC_7;
									break;

						case RC1_8:		rccode = RC_8;
									break;

						case RC1_9:		rccode = RC_9;
									break;

						case RC1_RED:		rccode = RC_RED;
									break;

						case RC1_GREEN:		rccode = RC_GREEN;
									break;

						case RC1_YELLOW:	rccode = RC_YELLOW;
									break;

						case RC1_BLUE:		rccode = RC_BLUE;
									break;

						case RC1_PLUS:		rccode = RC_PLUS;
									break;

						case RC1_MINUS:		rccode = RC_MINUS;
									break;

						case RC1_MUTE:		rccode = RC_MUTE;
									break;

						case RC1_HELP:		rccode = RC_HELP;
									break;

						case RC1_DBOX:		rccode = RC_DBOX;
									break;

						case RC1_HOME:		rccode = RC_HOME;
									break;

						case RC1_STANDBY:	rccode = RC_STANDBY;
					}
				}
				else
				{
					rccode &= 0x003F;
				}
		}
		else
		{
			rccode = -1;
		}

		return rccode;
}

#endif


int readconfig()
{
	FILE *fd_conf;
	char *ptr;
	char line_buffer[256];


	if(!(fd_conf = fopen(CFGFILE, "r")))
	{
		printf("[ievent] <could not read config file>\n");
		return 0;
	}


	while(fgets(line_buffer, sizeof(line_buffer), fd_conf))
	{
		if((ptr = strstr(line_buffer, "SERVER_IP="))) sscanf(ptr + 10, "%s", server_ip);

		else if((ptr = strstr(line_buffer, "SERVER_PORT="))) sscanf(ptr + 12, "%d", &server_port);

		else if((ptr = strstr(line_buffer, "SERVER_PASS="))) sscanf(ptr + 12, "%s", server_pass);
		
		else if((ptr = strstr(line_buffer, "CONSOLE_LOG="))) sscanf(ptr + 12, "%d", &console_log);
	}


	fclose(fd_conf);


	if(server_port< 1)
	{
		printf("[ievent] <invalid port number>\n");
		return 0;
	}

	if(server_ip=="")
	{
		printf("[ievent] <invalid server ip>\n");
		return 0;
	}
	
	if((console_log < 0) || (console_log > 1))
	{
		console_log=0;
	}

	return 1;

}


int socket_read (int m_fd,char *buf)
{
	int num_bytes;
	struct timeval tv;
	fd_set readfds;

	//timeout fr lesen
	tv.tv_sec = 1;
	tv.tv_usec =0;


	FD_ZERO(&readfds);
	FD_SET(m_fd, &readfds);

	select(m_fd+1, &readfds, NULL, NULL, &tv);

	//serverantwort lesen
	if (FD_ISSET(m_fd, &readfds))
	{
		//cookie lesen
		num_bytes=recv(m_fd, buf, BUFFER_SIZE-1, MSG_DONTWAIT | MSG_NOSIGNAL);
		return num_bytes;
	}
	else {
		printf("[ieventc] <no server response>\n");
		return 0;
	}
}

int socket_write (int m_fd,char *buf)
{

	if((send(m_fd, buf, strlen(buf), MSG_DONTWAIT | MSG_NOSIGNAL))<1)
	{
		printf("[ievent] <could'nt send, server died>\n");
		return 0;
	}
	
	return 1;

}

void plugin_exec(PluginParam *par)
{
        int count;
	FILE *fd_tmp;

	int fd_sock;
	struct sockaddr_in addr;
	char buffer[BUFFER_SIZE],wakeup[]="quintessence\n";
	//socklen_t addrlen;


	fb=-1;
	rc=-1;

	//get params


	for(; par; par = par->next)
	{

		if	(!strcmp(par->id, P_ID_RCINPUT)) rc = atoi(par->val);
		//else if	(!strcmp(par->id, P_ID_FBUFFER)) fb = atoi(par->val);
	}

	if( rc == -1)
	{
		printf("[ievent] <missing Param(s)>\n");
		return;
	}

	
	//set rc to blocking mode
	fcntl(rc, F_SETFL, fcntl(rc, F_GETFL) &~ O_NONBLOCK);

	//read configfile
	if (!readconfig()) return;

	//setup connection

	addr.sin_addr.s_addr = inet_addr(server_ip);
 	addr.sin_port = server_port;
 	addr.sin_family = AF_INET;

	if((fd_sock = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	{
		printf("[ievent] <Socketerror: socket failed>\n");
		return;
	}

	if(connect(fd_sock, (struct sockaddr*)&addr, sizeof(addr)) == -1)
	{
		printf("[ieventc] <Socketerror: connect failed>\n");
		close(fd_sock);
		return;
	}

	//startmessage senden
	if(!(socket_write(fd_sock, wakeup))) return;

	//set socket to non blocking mode
	//fcntl(fd_sock, F_SETFL, O_NONBLOCK);


	//read cookie
	if(socket_read(fd_sock,buffer)==0)return;

	buffer[4] = '\0';

	//tempfile fr md5 berechnung erzeugen
	if(!(fd_tmp = fopen(HASHFILE, "w")))
	{
		printf("[ievent] <could not create tempfile>\n");
		return;
	}

	//antwort string schreiben

	fprintf(fd_tmp, "%s:%s",buffer,server_pass);

	fclose(fd_tmp);


        //md5 von antwort berechnen
	if( md5_file(HASHFILE, 1, (unsigned char*) &md5buffer))
        {
 		exit(-1);
      	}

        //cryptedt antwortstring erzeugen
	for(count=0;count<16;count++)
        {
                //printf("%02x", md5buffer[count] );
		sprintf(buffer+count*2,"%02x", md5buffer[count] );
        }
	buffer[32]='\0';
	//printf("antwortstring:%s",buffer);

	//verschlsselte antwort senden
	if(!(socket_write(fd_sock, buffer))) return;

	//serverantwort lesen
	if(socket_read(fd_sock,buffer)==0) return;

	//connection accepted ?
	if(strstr(buffer, "accept")){
	
		printf("[ievent] connected to server: %s:%d\n",server_ip,server_port);
		
		//main loop
		do{
			
			rccode = GetRCCode();

			if (rccode <= RC_DBOX)
			{
				//eventstring senden
				sprintf(buffer,"%s\n",RCName[rccode]);

				if(!(socket_write(fd_sock, buffer))) return;

				if (console_log) printf("[ievent] eventstring \"%s\" sent\n",RCName[rccode]);
			}

	  	}while(rccode != RC_HOME);

		//"close" senden
		if(!(socket_write(fd_sock, "close\n"))) return;
	}
	else printf("[ievent] <connection not accepted>\n");

	close(fd_sock);

	fcntl(rc, F_SETFL, O_NONBLOCK);

        return;
}
